<active-game>
    <div if={game}>
        <div class="container mdl-grid">
            <div class="content mdl-color--white mdl-shadow--4dp content mdl-color-text--grey-800 mdl-cell mdl-cell--3-col">
                <div class="container">
                    <h3>Information</h3>
                    <h5>Your word: {game.playerWord}</h5>
                    <h5>{game.statusText || "Unknown"}</h5>
                    <div>
                        <button each="{letter in letters}"
                                class='mdl-button mdl-js-button mdl-button--fab mdl-button--mini-fab letter-box'
                                disabled="{game.status !== 'IN_PROGRESS'}"
                                data-status="{game.correctCharArray.includes(letter) ? 'correct' : game.incorrectCharArray.includes(letter) ? 'incorrect' : 'unknown'}"
                                data-letter={letter} onclick={handleLetterToggle}>
                            {letter.toUpperCase()}
                        </button>
                    </div>
                </div>
            </div>
            <div class="content mdl-color--white mdl-shadow--4dp content mdl-color-text--grey-800 mdl-cell mdl-cell--6-col">
                <div class="container">
                    <div class="mdl-grid">
                        <div class="mdl-cell mdl-cell--6-col mdl-cell--3-offset">
                            <form onsubmit={handleGuessSubmit} if="{game.status == 'IN_PROGRESS'}">
                                <div class="mdl-textfield mdl-js-textfield" id="guess-textfield">
                                    <input class="mdl-textfield__input" type="text" id="guess-input" name="guess"
                                           autocomplete="off" pattern="[A-Z,a-z]*" maxlength="5" minlength="5">
                                    <label class="mdl-textfield__label" for="guess-input">Your Next Guess</label>
                                </div>
                            </form>
                            <h3 if="{game.status !== 'IN_PROGRESS'}" style="text-align: center">You
                                {game.statusText}!</h3>
                        </div>
                    </div>
                    <div class="mdl-grid">
                        <div class="mdl-cell mdl-cell--6-col ">
                            <h4>Computer's Guesses</h4>
                            <ul class="mdl-list">
                                <li each={game.computerGuessList} class="mdl-list__item">
                                    <span class="mdl-list__item-primary-content">
                                        <span each={letter in guess}>
                                            { letter }
                                        </span> - { matchingChar }
                                    </span>
                                </li>
                            </ul>
                        </div>
                        <div class="mdl-cell mdl-cell--6-col float-right">
                            <h4 class="">Your Guesses</h4>
                            <ul class="mdl-list">
                                <li each={game.playerGuessList} class="mdl-list__item">
                                    <span class="mdl-list__item-primary-content">
                                        <span each={letter in guess} data-letter="{letter}"
                                              data-status="{game.correctCharArray.includes(letter) ? 'correct' : game.incorrectCharArray.includes(letter) ? 'incorrect' : 'unknown'}">
                                            { letter }
                                        </span> - { matchingChar }
                                    </span>
                                </li>
                            </ul>

                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
    <script>
        let game = null;
        let letters = [];

        this.on("updated", () => {
            componentHandler.upgradeAllRegistered();
        });

        this.on("mount", () => {
            riot.mount("back-button", {href: "/game/", text: "All Games"});

            // Setup letter grid
            const newLetters = [];
            for (let i = 0; i < 26; i++) {
                const char = (i + 10).toString(36);
                newLetters.push(char);
            }
            this.letters = newLetters;
            this.update();
        });

        this.on("route", (id) => {
            getOneGame(id)
                .then((game) => {
                    this.game = game;
                    this.update();
                })
                .catch(() => {
                    route("/");
                });
        });

        handleGuessSubmit = (e) => {
            e.preventDefault();
            const form = e.target;
            const input = form["guess"];
            const guess = input.value;
            submitGuess(guess, this.game.id)
                .then((game) => {
                    this.game = game;
                    this.update();
                })
                .catch((e) => {
                    console.log(e);
                    handleInvalidGuess(e);
                })
                .finally(() => {
                    input.value = "";
                    input.parentElement.MaterialTextfield.change();
                });
        };

        handleInvalidGuess = (message) => {
            const snackbarContainer = document.querySelector('#error-notification');
            const data = {message: message, timeout: 5000};
            snackbarContainer.MaterialSnackbar.showSnackbar(data);
        };

        handleLetterToggle = (e) => {
            const el = e.target;
            const letter = el.getAttribute("data-letter");
            const currStatus = el.getAttribute("data-status");
            let newStatus;
            switch (currStatus) {
                case "unknown":
                    newStatus = "correct";
                    break;
                case "correct":
                    newStatus = "incorrect";
                    break;
                default:
                    newStatus = "unknown";
            }
            el.setAttribute("data-status", newStatus);
            const els = document.querySelectorAll(`[data-letter=${letter}]`);
            els.forEach((element) => {
                element.setAttribute("data-status", newStatus);
            });
            submitLetterStatus(letter, newStatus, this.game.id);
        };

    </script>
</active-game>
